<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="usersId"
          :columns="columns"
          :datasource="datasource"
          :scroll="{ x: 2200 }"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'avatarUrl'">
              <a-avatar
                :size="30"
                :src="`${record.avatarUrl}`"
                style="margin-right: 4px"
              >
                <template #icon>
                  <UserOutlined />
                </template>
              </a-avatar>
            </template>
            <template v-if="column.key === 'gender'">
              <a-tag v-if="record.gender == 1">男</a-tag>
              <a-tag v-if="record.gender == 2">女</a-tag>
              <span v-if="record.gender == 0"></span>
            </template>
            <template v-if="column.key === 'isAdmin'">
              <a-switch
                :checked="record.isAdmin == 1"
                @change="updateIsAdmin(record)"
              />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a>积分充值</a>
                <!--                <a @click="openEdit(record)">修改</a>-->
                <!--                <a-divider type="vertical" />-->
                <!--                <a-popconfirm-->
                <!--                  title="确定要删除此记录吗？"-->
                <!--                  @confirm="remove(record)"-->
                <!--                >-->
                <!--                  <a class="ele-text-danger">删除</a>-->
                <!--                </a-popconfirm>-->
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <Edit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { UserOutlined } from '@ant-design/icons-vue';
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import Edit from './components/bookingUserEdit.vue';
  import {
    pageBookingUser,
    removeBookingUser,
    removeBatchBookingUser,
    updateBookingUser
  } from '@/api/booking/bookingUser';
  import type {
    BookingUser,
    BookingUserParam
  } from '@/api/booking/bookingUser/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<BookingUser[]>([]);
  // 当前编辑数据
  const current = ref<BookingUser | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageBookingUser({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '用户ID',
      dataIndex: 'id',
      key: 'id',
      width: 90
    },
    {
      title: '用户唯一小程序id',
      dataIndex: 'openId',
      key: 'openId',
      align: 'center',
      hideInTable: true
    },
    {
      title: '小程序用户秘钥',
      dataIndex: 'sessionKey',
      key: 'sessionKey',
      align: 'center',
      hideInTable: true
    },
    {
      title: '用户名',
      dataIndex: 'username',
      key: 'username',
      align: 'center'
    },
    {
      title: '头像',
      dataIndex: 'avatarUrl',
      key: 'avatarUrl',
      align: 'center'
    },
    {
      title: '性别',
      dataIndex: 'gender',
      key: 'gender',
      align: 'center'
    },
    {
      title: '手机号码',
      dataIndex: 'phone',
      key: 'phone',
      align: 'center',
      sorter: true
    },
    {
      title: '积分',
      dataIndex: 'integral',
      key: 'integral',
      align: 'center',
      sorter: true
    },
    {
      title: '余额',
      dataIndex: 'money',
      key: 'money',
      align: 'center',
      sorter: true
    },
    {
      title: '身份证号码',
      dataIndex: 'idcard',
      key: 'idcard',
      align: 'center'
    },
    {
      title: '真实姓名',
      dataIndex: 'truename',
      key: 'truename',
      align: 'center'
    },
    {
      title: '国家',
      dataIndex: 'country',
      key: 'country',
      align: 'center'
    },
    {
      title: '省份',
      dataIndex: 'province',
      key: 'province',
      align: 'center'
    },
    {
      title: '城市',
      dataIndex: 'city',
      key: 'city',
      align: 'center'
    },
    {
      title: '是否管理员',
      dataIndex: 'isAdmin',
      key: 'isAdmin',
      align: 'center'
    },
    {
      title: '注册时间',
      dataIndex: 'createTime',
      key: 'createTime',
      align: 'center',
      sorter: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: BookingUserParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: BookingUser) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: BookingUser) => {
    const hide = message.loading('请求中..', 0);
    removeBookingUser(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchBookingUser(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 修改用户状态 */
  const updateIsAdmin = (row: BookingUser) => {
    row.isAdmin = row.isAdmin == 1 ? 2 : 1;
    updateBookingUser(row)
      .then((msg) => {
        message.success(msg);
      })
      .catch((e) => {
        message.error(e.message);
      });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: BookingUser) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'BookingUser'
  };
</script>

<style lang="less" scoped></style>
